/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
/**
 * @author Generated on 06/06/2018 15:54:42+0200 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige3.core::vo::administration::strategy::PmfmAppliedStrategyVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige3.core.vo.administration.strategy;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * PMSF associés à une stratégie pour un lieu données.
 */
public class PmfmAppliedStrategyVO
    implements Serializable, Comparable<PmfmAppliedStrategyVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = -5760269556011704032L;

    // Class attributes
    /**
     * Date de modification de l'objet, mise à jour par le système
     */
    protected Timestamp updateDt;
    /**
     * Identifiant de l'engin
     */
    protected Integer analInstId;
    /**
     * Identifiant interne d'un service
     */
    protected Integer depId;
    /** TODO: Model Documentation for attribute appliedStratId */
    protected Integer appliedStratId;
    /** TODO: Model Documentation for attribute pmfmStratId */
    protected Integer pmfmStratId;

    // Class associationEnds
    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     */
    protected AppliedStrategyVO appliedStrategyVO;

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     */
    protected PmfmStrategyVO pmfmStrategyVO;

    /** Default Constructor with no properties */
    public PmfmAppliedStrategyVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param appliedStratIdIn Integer
     * @param pmfmStratIdIn Integer
     * @param appliedStrategyVOIn AppliedStrategyVO Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * @param pmfmStrategyVOIn PmfmStrategyVO PSFM associés à une stratégie
PMSF associés à une stratégie.
     */
    public PmfmAppliedStrategyVO(final Integer appliedStratIdIn, final Integer pmfmStratIdIn, final AppliedStrategyVO appliedStrategyVOIn, final PmfmStrategyVO pmfmStrategyVOIn)
    {
        this.appliedStratId = appliedStratIdIn;
        this.pmfmStratId = pmfmStratIdIn;
        this.appliedStrategyVO = appliedStrategyVOIn;
        this.pmfmStrategyVO = pmfmStrategyVOIn;
    }

    /**
     * Constructor with all properties
     * @param updateDtIn Timestamp
     * @param analInstIdIn Integer
     * @param depIdIn Integer
     * @param appliedStratIdIn Integer
     * @param pmfmStratIdIn Integer
     * @param appliedStrategyVOIn AppliedStrategyVO
     * @param pmfmStrategyVOIn PmfmStrategyVO
     */
    public PmfmAppliedStrategyVO(final Timestamp updateDtIn, final Integer analInstIdIn, final Integer depIdIn, final Integer appliedStratIdIn, final Integer pmfmStratIdIn, final AppliedStrategyVO appliedStrategyVOIn, final PmfmStrategyVO pmfmStrategyVOIn)
    {
        this.updateDt = updateDtIn;
        this.analInstId = analInstIdIn;
        this.depId = depIdIn;
        this.appliedStratId = appliedStratIdIn;
        this.pmfmStratId = pmfmStratIdIn;
        this.appliedStrategyVO = appliedStrategyVOIn;
        this.pmfmStrategyVO = pmfmStrategyVOIn;
    }

    /**
     * Copies constructor from other PmfmAppliedStrategyVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public PmfmAppliedStrategyVO(final PmfmAppliedStrategyVO otherBean)
    {
        this.updateDt = otherBean.getUpdateDt();
        this.analInstId = otherBean.getAnalInstId();
        this.depId = otherBean.getDepId();
        this.appliedStratId = otherBean.getAppliedStratId();
        this.pmfmStratId = otherBean.getPmfmStratId();
        this.appliedStrategyVO = otherBean.getAppliedStrategyVO();
        this.pmfmStrategyVO = otherBean.getPmfmStrategyVO();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final PmfmAppliedStrategyVO otherBean)
    {
        if (null != otherBean)
        {
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setAnalInstId(otherBean.getAnalInstId());
            this.setDepId(otherBean.getDepId());
            this.setAppliedStratId(otherBean.getAppliedStratId());
            this.setPmfmStratId(otherBean.getPmfmStratId());
            this.setAppliedStrategyVO(otherBean.getAppliedStrategyVO());
            this.setPmfmStrategyVO(otherBean.getPmfmStrategyVO());
        }
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * Identifiant de l'engin
     * Get the analInstId Attribute
     * @return analInstId Integer
     */
    public Integer getAnalInstId()
    {
        return this.analInstId;
    }

    /**
     * Identifiant de l'engin
     * @param value Integer
     */
    public void setAnalInstId(final Integer value)
    {
        this.analInstId = value;
    }

    /**
     * Identifiant interne d'un service
     * Get the depId Attribute
     * @return depId Integer
     */
    public Integer getDepId()
    {
        return this.depId;
    }

    /**
     * Identifiant interne d'un service
     * @param value Integer
     */
    public void setDepId(final Integer value)
    {
        this.depId = value;
    }

    /**
     * TODO: Model Documentation for attribute appliedStratId
     * Get the appliedStratId Attribute
     * @return appliedStratId Integer
     */
    public Integer getAppliedStratId()
    {
        return this.appliedStratId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setAppliedStratId(final Integer value)
    {
        this.appliedStratId = value;
    }

    /**
     * TODO: Model Documentation for attribute pmfmStratId
     * Get the pmfmStratId Attribute
     * @return pmfmStratId Integer
     */
    public Integer getPmfmStratId()
    {
        return this.pmfmStratId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setPmfmStratId(final Integer value)
    {
        this.pmfmStratId = value;
    }

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * Get the appliedStrategyVO Association
     * @return this.appliedStrategyVO AppliedStrategyVO
     */
    public AppliedStrategyVO getAppliedStrategyVO()
    {
        return this.appliedStrategyVO;
    }

    /**
     * Sets the appliedStrategyVO
     * @param value AppliedStrategyVO
     */
    public void setAppliedStrategyVO(AppliedStrategyVO value)
    {
        this.appliedStrategyVO = value;
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * Get the pmfmStrategyVO Association
     * @return this.pmfmStrategyVO PmfmStrategyVO
     */
    public PmfmStrategyVO getPmfmStrategyVO()
    {
        return this.pmfmStrategyVO;
    }

    /**
     * Sets the pmfmStrategyVO
     * @param value PmfmStrategyVO
     */
    public void setPmfmStrategyVO(PmfmStrategyVO value)
    {
        this.pmfmStrategyVO = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        PmfmAppliedStrategyVO rhs = (PmfmAppliedStrategyVO) object;
        return new EqualsBuilder()
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getAnalInstId(), rhs.getAnalInstId())
            .append(this.getDepId(), rhs.getDepId())
            .append(this.getAppliedStratId(), rhs.getAppliedStratId())
            .append(this.getPmfmStratId(), rhs.getPmfmStratId())
            .append(this.getAppliedStrategyVO(), rhs.getAppliedStrategyVO())
            .append(this.getPmfmStrategyVO(), rhs.getPmfmStrategyVO())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final PmfmAppliedStrategyVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getAnalInstId(), object.getAnalInstId())
            .append(this.getDepId(), object.getDepId())
            .append(this.getAppliedStratId(), object.getAppliedStratId())
            .append(this.getPmfmStratId(), object.getPmfmStratId())
            .append(this.getAppliedStrategyVO(), object.getAppliedStrategyVO())
            .append(this.getPmfmStrategyVO(), object.getPmfmStrategyVO())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getUpdateDt())
            .append(this.getAnalInstId())
            .append(this.getDepId())
            .append(this.getAppliedStratId())
            .append(this.getPmfmStratId())
            .append(this.getAppliedStrategyVO())
            .append(this.getPmfmStrategyVO())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("updateDt", this.getUpdateDt())
            .append("analInstId", this.getAnalInstId())
            .append("depId", this.getDepId())
            .append("appliedStratId", this.getAppliedStratId())
            .append("pmfmStratId", this.getPmfmStratId())
            .append("appliedStrategyVO", this.getAppliedStrategyVO())
            .append("pmfmStrategyVO", this.getPmfmStrategyVO())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // PmfmAppliedStrategyVO value-object java merge-point
}